apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ .Chart.Name }}
  labels:
    {{- range $key, $value := .Values.tetris.labels }}
      {{ $key }}: {{ $value }}
    {{- end }}
spec:
  replicas: {{ .Values.tetris.replicaCount }}
  minReadySeconds: 10
  strategy:
    rollingUpdate:
    {{- range $key, $value := .Values.tetris.rollingUpdate }}
      {{ $key }}: {{ $value }}
    {{- end }}
    type: {{ .Values.tetris.Strategy }}
  selector:
    matchLabels:
    {{- range $key, $value := .Values.tetris.labels }}
      {{ $key }}: {{ $value }}
    {{- end }}
  template:
    metadata:
      labels:
      {{- range $key, $value := .Values.tetris.labels }}
        {{ $key }}: {{ $value }}
      {{- end }}
    spec:
      containers:
      - name: {{ .Values.tetris.name }}
        image: {{ .Values.tetris.image.repository }}:{{ .Values.tetris.image.tag }}
        ports:
        {{- range $key, $value := .Values.tetris.ports }}
          - containerPort: {{ $value}}
            name: {{ $key }}
        {{- end }}
        livenessProbe:
          httpGet:
            path: /
            port: 80
          initialDelaySeconds: 10
          periodSeconds: 5
        readinessProbe:
          httpGet:
            path: /
            port: 80
          initialDelaySeconds: 10
          periodSeconds: 5
        resources:
          requests:
            {{- range $key, $value := .Values.tetris.Resources.requests }}
              {{ $key }}: {{ $value }}
            {{- end}}
          limits:
            {{- range $key, $value := .Values.tetris.Resources.limits }}
              {{ $key }}: {{ $value }}
            {{- end}}
